#include "Scenes.h"

void Scenes::LoadResources(Game& localGame)
{
	TTF_Init();
	Sans = TTF_OpenFont("Assets/Calibri.ttf", 24);
	SmallerSans = TTF_OpenFont("Assets/Calibri.ttf", 16);

	//Inicjalizacja statycznych textur
	logoTexture = localGame.LoadTexture("Assets\\imgs\\logo.png");

	//Inicjalizacja przycisku trening
	trainingButton.Init(0, 0, localGame.LoadTexture("Assets\\imgs\\trainingButton_d.png"), 2, true);
	trainingButton.SetTexture(1, localGame.LoadTexture("Assets\\imgs\\trainingButton_u.png"));
	trainingButton.SetTexture(2, localGame.LoadTexture("Assets\\imgs\\trainingButton_p.png"));
	trainingButton.SetTexture(3, localGame.LoadTexture("Assets\\imgs\\trainingButton_g.png"));

	//Inicjalizacja przycisku newgame
	newgameButton.Init(0, 0, localGame.LoadTexture("Assets\\imgs\\newgameButton_d.png"), 2, true);
	newgameButton.SetTexture(1, localGame.LoadTexture("Assets\\imgs\\newgameButton_u.png"));
	newgameButton.SetTexture(2, localGame.LoadTexture("Assets\\imgs\\newgameButton_p.png"));
	newgameButton.SetTexture(3, localGame.LoadTexture("Assets\\imgs\\newgameButton_g.png"));

	//Inicjalizacja przycisku continue
	continueButton.Init(0, 0, localGame.LoadTexture("Assets\\imgs\\continueButton_d.png"), 2, true);
	continueButton.SetTexture(1, localGame.LoadTexture("Assets\\imgs\\continueButton_u.png"));
	continueButton.SetTexture(2, localGame.LoadTexture("Assets\\imgs\\continueButton_p.png"));
	continueButton.SetTexture(3, localGame.LoadTexture("Assets\\imgs\\continueButton_g.png"));

	//Inicjalizacja przycisku usermaps
	usermapsButton.Init(0, 0, localGame.LoadTexture("Assets\\imgs\\usermapsButton_d.png"), 2, true);
	usermapsButton.SetTexture(1, localGame.LoadTexture("Assets\\imgs\\usermapsButton_u.png"));
	usermapsButton.SetTexture(2, localGame.LoadTexture("Assets\\imgs\\usermapsButton_p.png"));
	usermapsButton.SetTexture(3, localGame.LoadTexture("Assets\\imgs\\usermapsButton_g.png"));

	//Inicjalizacja uiButton (przycisku back)
	backButton.Init(48, 96, localGame.LoadTexture("Assets\\imgs\\uiButton32_d.png"), 1, true);
	backButton.SetTexture(1, localGame.LoadTexture("Assets\\imgs\\uiButton32_u.png"));
	backButton.SetTexture(2, localGame.LoadTexture("Assets\\imgs\\uiButton32_p.png"));
	backButton.SetTexture(3, localGame.LoadTexture("Assets\\imgs\\uiButton32_g.png"));
	backOverlay = localGame.LoadTexture("Assets\\imgs\\backOverlay.png");

	//Inicjalizacja podwietle map
	mapButtons[0].Init(0, 0, localGame.LoadTexture("Assets\\imgs\\mapbg_d.png"), 6, true);
	mapButtons[0].SetTexture(1, localGame.LoadTexture("Assets\\imgs\\mapbg_u.png"));
	mapButtons[0].SetTexture(2, localGame.LoadTexture("Assets\\imgs\\mapbg_p.png"));

	mapButtons[2] = mapButtons[1] = mapButtons[0];

	//Inicjalizacja przyciskw kontroli customowych map
	usermapButtons[3] = backButton;
	usermapButtons[3].s = 2;
	usermapButtons[0] = usermapButtons[1] = usermapButtons[2] = usermapButtons[3];

	usermapsOverlay = localGame.LoadTexture("Assets\\imgs\\usermapsOverlay.png");
	usermapsPlus = localGame.LoadTexture("Assets\\imgs\\usermapsPlus.png");

	//Inicjalizacja przyciskw przewijania stron
	prevMapButton.Init(0, 0, localGame.LoadTexture("Assets\\imgs\\prevMapButton_d.png"), 2, true);
	prevMapButton.SetTexture(1, localGame.LoadTexture("Assets\\imgs\\prevMapButton_u.png"));
	prevMapButton.SetTexture(2, localGame.LoadTexture("Assets\\imgs\\prevMapButton_p.png"));
	prevMapButton.SetTexture(3, localGame.LoadTexture("Assets\\imgs\\prevMapButton_g.png"));
	nextMapButton.Init(0, 0, localGame.LoadTexture("Assets\\imgs\\nextMapButton_d.png"), 2, true);
	nextMapButton.SetTexture(1, localGame.LoadTexture("Assets\\imgs\\nextMapButton_u.png"));
	nextMapButton.SetTexture(2, localGame.LoadTexture("Assets\\imgs\\nextMapButton_p.png"));
	nextMapButton.SetTexture(3, localGame.LoadTexture("Assets\\imgs\\nextMapButton_g.png"));

	//Inicjalizacja tekstur panelu gratulacyjnego
	congratulationsButton = localGame.LoadTexture("Assets\\imgs\\congratulationsButton.png");
	congratulationsHeader = localGame.LoadTexture("Assets\\imgs\\congratulationsHeader.png");
	congratulationsArrow = localGame.LoadTexture("Assets\\imgs\\congratulationsArrow.png");

	//Inicjalizacja przyciskw wyboru poziomu trudnoci
	difficultyButtons[0].Init(0, 0, localGame.LoadTexture("Assets\\imgs\\mapbg_d.png"), 6, true);
	difficultyButtons[0].SetTexture(1, localGame.LoadTexture("Assets\\imgs\\mapbg_u.png"));
	difficultyButtons[0].SetTexture(2, localGame.LoadTexture("Assets\\imgs\\mapbg_p.png"));

	difficultyButtons[2] = difficultyButtons[1] = difficultyButtons[0];

	difficultyImages[0] = localGame.LoadTexture("Assets\\imgs\\difficulty1.png");
	difficultyImages[1] = localGame.LoadTexture("Assets\\imgs\\difficulty2.png");
	difficultyImages[2] = localGame.LoadTexture("Assets\\imgs\\difficulty3.png");

	difficultyBanner = localGame.LoadTexture("Assets\\imgs\\difficultyBanner.png");

	//Inicjalizacja overlayw do gry
	pauseOverlay = localGame.LoadTexture("Assets\\imgs\\pauseOverlay.png");
	blackDot = localGame.LoadTexture("Assets\\imgs\\blackDot.png");
	restartOverlay = localGame.LoadTexture("Assets\\imgs\\restartOverlay.png");

	//Inicjalizacja IGM
	igmButtons[0].Init(0, 0, localGame.LoadTexture("Assets\\imgs\\uiButtonFinished_d.png"), 2, true);
	igmButtons[0].SetTexture(1, localGame.LoadTexture("Assets\\imgs\\uiButtonFinished_u.png"));
	igmButtons[0].SetTexture(2, localGame.LoadTexture("Assets\\imgs\\uiButtonFinished_p.png"));
	igmButtons[0].SetTexture(3, localGame.LoadTexture("Assets\\imgs\\uiButtonFinished_g.png"));

	igmButtons[2] = igmButtons[1] = igmButtons[0];

	igmBackgrounds[0] = localGame.LoadTexture("Assets\\imgs\\levelFinished.png");
	igmBackgrounds[1] = localGame.LoadTexture("Assets\\imgs\\levelFailure.png");
	igmBackgrounds[2] = localGame.LoadTexture("Assets\\imgs\\levelPause.png");
	igmBackgrounds[3] = localGame.LoadTexture("Assets\\imgs\\trainingFinished.png");
	igmBackgrounds[4] = localGame.LoadTexture("Assets\\imgs\\trainingPause.png");
	igmBackgrounds[5] = localGame.LoadTexture("Assets\\imgs\\levelWaterFailure.png");
	igmBackgrounds[6] = localGame.LoadTexture("Assets\\imgs\\customFinished.png");
	igmBackgrounds[7] = localGame.LoadTexture("Assets\\imgs\\customPause.png");
	igmBackgrounds[8] = localGame.LoadTexture("Assets\\imgs\\customExitSave.png");

	unpauseButton = backButton;

	//Inicjalizacja tekstur mapy
	mapTextures[0] = localGame.LoadTexture("Assets\\imgs\\maptextures\\concrete.png");
	mapTextures[1] = localGame.LoadTexture("Assets\\imgs\\maptextures\\bricks.png");
	mapTextures[2] = localGame.LoadTexture("Assets\\imgs\\maptextures\\box.png");
	mapTextures[3] = localGame.LoadTexture("Assets\\imgs\\maptextures\\waterbox.png");
	mapTextures[4] = localGame.LoadTexture("Assets\\imgs\\maptextures\\water.png");
	mapTextures[5] = localGame.LoadTexture("Assets\\imgs\\maptextures\\black.png");
	mapTextures[6] = localGame.LoadTexture("Assets\\imgs\\maptextures\\target.png");
	mapTextures[7] = localGame.LoadTexture("Assets\\imgs\\maptextures\\dummyPlayer.png");
	mapTextures[11] = localGame.LoadTexture("Assets\\imgs\\maptextures\\bricks2.png");
	mapTextures[15] = nullptr;

	lightOverlay = localGame.LoadTexture("Assets\\imgs\\light.png");
	darknessOverlay = localGame.LoadTexture("Assets\\imgs\\darkness.png");

	//Inicjalizacja tekstur tabelki wynikw
	tableEntryImage = localGame.LoadTexture("Assets\\imgs\\scoretable\\tableentry.png");
	tableHeaderImage = localGame.LoadTexture("Assets\\imgs\\scoretable\\tableheader.png");

	medalImage[0] = localGame.LoadTexture("Assets\\imgs\\scoretable\\medal1.png");
	medalImage[1] = localGame.LoadTexture("Assets\\imgs\\scoretable\\medal2.png");
	medalImage[2] = localGame.LoadTexture("Assets\\imgs\\scoretable\\medal3.png");

	floppyButton.Init(-16, -16, localGame.LoadTexture("Assets\\imgs\\scoretable\\floppy_d.png"), 2, true);
	floppyButton.SetTexture(1, localGame.LoadTexture("Assets\\imgs\\scoretable\\floppy_u.png"));
	floppyButton.SetTexture(2, localGame.LoadTexture("Assets\\imgs\\scoretable\\floppy_p.png"));

	//Inicjalizacja narzdzi edytora map
	for (int i = 0; i < 9; i++)
	{
		editorToolsButtons[i] = backButton; //backbutton jest baz dla wszystkich ui32 przyciskw XD
		editorToolsButtons[i].s = 2;
		editorToolsButtons[i].y = 192 + 64 * i;

		editorLeftSideButtons[i] = backButton;
	}

	editorLeftSideButtons[0].x = 96;
	editorLeftSideButtons[1].x = editorLeftSideButtons[4].x = editorLeftSideButtons[6].x = editorLeftSideButtons[8].x = 144;
	editorLeftSideButtons[2].x = 192;

	editorLeftSideButtons[0].y = editorLeftSideButtons[1].y = editorLeftSideButtons[2].y = 48;
	editorLeftSideButtons[3].y = editorLeftSideButtons[4].y = 96;
	editorLeftSideButtons[5].y = editorLeftSideButtons[6].y = 144;
	editorLeftSideButtons[7].y = editorLeftSideButtons[8].y = 192;

	editorOverlay = localGame.LoadTexture("Assets\\imgs\\editorOverlay.png");
	tileOverlay = localGame.LoadTexture("Assets\\imgs\\tileOverlay.png");

	CalcDynamicPositions(localGame);

	soundManager.LoadMusic("music_menu", "Assets//audio//music//music_menu.wav");
	soundManager.LoadMusic("music_game", "Assets//audio//music//music_game.wav");

	soundManager.LoadEffect("effect_splash", "Assets//audio//effects/effect_splash.wav");
	soundManager.LoadEffect("effect_slide", "Assets//audio//effects/effect_slide.wav");
	soundManager.LoadEffect("effect_win", "Assets//audio//effects/effect_win.wav");
	soundManager.LoadEffect("effect_winshort", "Assets//audio//effects/effect_winshort.wav");
	soundManager.LoadEffect("effect_tick", "Assets//audio//effects/effect_tick.wav");

	//Inicjalizacja tekstur gracza

	for (int i = 0; i < 3; i++)
		playerTextures[i].Init(localGame.LoadTexture(("Assets\\imgs\\playerTextures\\" + to_string(i+1) + ".png").c_str()), GSCALE, GSCALE);
		//boze jaki ten kod jest piekny *-*
}

void Scenes::CalcDynamicPositions(Game& localGame)
{

	continueButton.x = usermapsButton.x = newgameButton.x = trainingButton.x = round(localGame.windowWidth * 0.5f);
	trainingButton.y = round(localGame.windowHeight * 0.6f);
	newgameButton.y = round(localGame.windowHeight * 0.6f) + 48;
	continueButton.y = round(localGame.windowHeight * 0.6f) + 48 * 2;
	usermapsButton.y = round(localGame.windowHeight * 0.6f) + 48 * 3;

	mapButtons[0].y = mapButtons[1].y = mapButtons[2].y = round(localGame.windowHeight * 0.7f);

	mapButtons[0].x = round(localGame.windowWidth * 0.5f) - 256;
	mapButtons[1].x = round(localGame.windowWidth * 0.5f);
	mapButtons[2].x = round(localGame.windowWidth * 0.5f) + 256;

	usermapButtons[0].y = usermapButtons[1].y = round(localGame.windowHeight * 0.7f) - 48;
	usermapButtons[2].y = usermapButtons[3].y = round(localGame.windowHeight * 0.7f) + 48;

	prevMapButton.x = round(localGame.windowWidth * 0.5f) - 410;
	nextMapButton.x = round(localGame.windowWidth * 0.5f) + 410;
	nextMapButton.y = prevMapButton.y = round(localGame.windowHeight * 0.7f);

	difficultyButtons[0].y = difficultyButtons[1].y = difficultyButtons[2].y = round(localGame.windowHeight * 0.7f);
	difficultyButtons[0].x = round(localGame.windowWidth * 0.5f) - 256;
	difficultyButtons[1].x = round(localGame.windowWidth * 0.5f);
	difficultyButtons[2].x = round(localGame.windowWidth * 0.5f) + 256;

	igmButtons[0].x = round(localGame.windowWidth * 0.5f) - 220;
	igmButtons[1].x = round(localGame.windowWidth * 0.5f);
	igmButtons[2].x = round(localGame.windowWidth * 0.5f) + 220;
	igmButtons[0].y = igmButtons[1].y = igmButtons[2].y = round(localGame.windowHeight * 0.5f) + 196;

	for (int i = 0; i < 9; i++) editorToolsButtons[i].x = localGame.windowWidth - 32;

	unpauseButton.y = (round(localGame.windowHeight * 0.5f)) - 206;
	unpauseButton.x = (round(localGame.windowWidth * 0.5f)) + 325;
}