#include "Scenes.h"

Scenes::Scenes()
{

}

Scenes::~Scenes()
{

}

void Scenes::MainMenuUpdate(Game& localGame) //wywietlanie menu gwnego
{

	localGame.DrawTexture(logoTexture, localGame.windowWidth / 2, localGame.windowHeight / 4, 2);

	if (trainingButton.Update(localGame)) currentScene = 3;
	if (newgameButton.Update(localGame))
	{
		mapManager.selectedMap = 0;
		currentScene = 2;
		selectedSave = -1;
		selectedDifficulty = -1;
		saveManager.ListSaves();
		mapManager.ListMaps();
		selectedSaveName = "Zapis " + to_string(saveManager.savesCount + 1);
	}
	if (continueButton.Update(localGame))
	{
		currentScene = 4;
	}
	if (usermapsButton.Update(localGame))
	{
		currentScene = 1;
	}
}

void Scenes::MapMenuUpdate(Game& localGame) //wywietlanie menu trybu edytora
{


	if (ticksInCurrentScene == 0)
	{
		mapManager.selectedMap = -1;
		selectedDifficulty = 99;
		afteredit = false;

		backButton.y = 48;

		mapManager.ListMaps("UserMaps");

		saveManager.ListSaves();
		if (saveManager.saves[saveManager.savesCount - 1].name == "ZZ-EDITOR-")
		{
			selectedSave = saveManager.savesCount - 1;
			mapManager.selectedMap = saveManager.saves[saveManager.savesCount - 1].currentLevel;
			currentScene = 2;
			ticksInCurrentScene = -1;
			filesystem::remove("Saves\\ZZ-EDITOR-.sav");
		}
	}

	localGame.DrawTexture(logoTexture, localGame.windowWidth / 2, localGame.windowHeight / 4, 2);
	localGame.DrawTexture(backOverlay, 48, 48, 1);

	string pagenoString = "strona " + to_string(pageno + 1) + "/" + to_string(lastPage + 1);

	localGame.RenderText(
		Sans,
		{ 255,255,255,255 },
		pagenoString.c_str(),
		round(localGame.windowWidth * 0.5f),
		round(localGame.windowHeight * 0.9f),
		1
	);

	lastPage = ((mapManager.mapsCount - 1) / 3);

	if (nextMapButton.Update(localGame))
	{
		pageno++;
		if (pageno > lastPage) pageno = 0;
	}
	if (prevMapButton.Update(localGame))
	{
		pageno--;
		if (pageno < 0) pageno = lastPage;
	}
	if (backButton.Update(localGame))
	{
		currentScene = 0;
	}

	for (int i = 0; i < 3; i++)
	{
		int mapid = pageno * 3 + i;

		if (mapManager.mapsCount > mapid)
		{
			if (mapButtons[i].a == 3) mapButtons[i].a = 0;


			tempCursorX = round(localGame.windowWidth * 0.5f) + (i - 1) * 256;

			if (mapid == 0)
			{
				localGame.DrawTexture(usermapsPlus, tempCursorX, round(localGame.windowHeight * 0.7f), 2);

				if (mapButtons[0].Update(localGame))
				{
					currentScene = 5;
					mapManager.selectedMap = 0;
					selectedDifficulty = 99;
					selectedSave = -1;
					afteredit = true;
				}

				localGame.RenderText(
					Sans,
					{ 255,255,255,255 },
					"Nowa mapa",
					round(tempCursorX),
					round(localGame.windowHeight * 0.7f) - 140,
					1
				);
			}
			else
			{
				if (mapButtons[i].a == 1 || mapButtons[i].a == 3)
				{

					usermapButtons[0].x = usermapButtons[2].x = tempCursorX - 48;
					usermapButtons[1].x = usermapButtons[3].x = tempCursorX + 48;

					if (usermapButtons[0].Update(localGame))
					{
						selectedDifficulty = 99;
						currentScene = 5;
						mapManager.selectedMap = mapid;
						selectedSave = -1;
						afteredit = true;
					}
					if (usermapButtons[1].Update(localGame))
					{
						std::filesystem::rename(mapManager.maps[mapid].filename, ("Deleted" + mapManager.maps[mapid].filename));
						ticksInCurrentScene = -1;
					}
					if (usermapButtons[2].Update(localGame))
					{
						selectedDifficulty = 99;
						mapManager.selectedMap = mapid;
						currentScene = 2;
						selectedSave = -1;
						afteredit = false;
					}
					if (usermapButtons[3].Update(localGame))
					{
						string filename = mapManager.maps[mapid].filename;
						std::filesystem::copy(filename, filename.substr(0, filename.size() - 4) + "copy" + to_string(rand()) + ".map");
						ticksInCurrentScene = -1;
					}

					localGame.DrawTexture(usermapsOverlay, tempCursorX, round(localGame.windowHeight * 0.7f), 2);
				}
				else for (int y = 0; y < mapManager.maps[mapid].height * 4; y++)
				{
					for (int x = 0; x < mapManager.maps[mapid].width * 4; x++)
					{
						bool draw = true;

						switch (mapManager.maps[mapid].map[y / 4][x / 4])
						{
						case '#':
						case 'W':
							SDL_SetRenderDrawColor(localGame.renderer, 255, 255, 255, 255);
							break;
						case 'B':
							SDL_SetRenderDrawColor(localGame.renderer, 0, 0, 255, 255);
							break;
						case 'P':
							SDL_SetRenderDrawColor(localGame.renderer, 255, 255, 0, 255);
							break;
						case 'T':
							SDL_SetRenderDrawColor(localGame.renderer, 255, 0, 0, 255);
							break;
						default:
							draw = false;
							break;
						}

						if (draw) SDL_RenderDrawPoint(localGame.renderer, tempCursorX - (mapManager.maps[mapid].width * 2) + x, round(localGame.windowHeight * 0.7f) - (mapManager.maps[mapid].height * 2) + y);
					}

					SDL_SetRenderDrawColor(localGame.renderer, 0, 0, 0, 255);
				}
			}

			mapButtons[i].Update(localGame);
		}
		else
		{
			mapButtons[i].a = 3;
		}
	}
}

void Scenes::DifficultyMenuUpdate(Game& localGame) //wywietlanie menu trybu treningu
{

	if (ticksInCurrentScene == 0)
	{
		selectedDifficulty = -1;

		backButton.y = 48;
	}

	localGame.DrawTexture(logoTexture, localGame.windowWidth / 2, localGame.windowHeight / 4, 2);
	localGame.DrawTexture(backOverlay, 48, 48, 1);
	localGame.DrawTexture(difficultyBanner, round(localGame.windowWidth * 0.5f) - 256, round(localGame.windowHeight * 0.7f) - 140, 2);

	for (int i = 0; i < 3; i++) //rysowanie i interakcja przyskw wyboru poziomu trudnoci
	{
		localGame.DrawTexture(difficultyImages[i], round(localGame.windowWidth * 0.5f) + (i - 1) * 256, round(localGame.windowHeight * 0.7f), 1);
		if (difficultyButtons[i].Update(localGame))
		{
			selectedDifficulty = i + 1;
			mapManager.selectedMap = mapManager.GetRandomMapID(selectedDifficulty);
			currentScene = 2;
			selectedSave = -1;
		}
	}

	if (backButton.Update(localGame))
	{
		currentScene = 0;
	}
}

void Scenes::RenderGameMap(Game& localGame, bool dummy) //renderowanie statycznych elementw mapy
{
	Map* amap = &mapManager.maps[mapManager.selectedMap];
	SDL_Texture** currentTexture;

	int xoffset = (localGame.windowWidth / 2) - (amap->width * GSCALE / 2);
	int yoffset = (localGame.windowHeight / 2) - (amap->height * GSCALE / 2);

	for (int y = 0; y < amap->height; y += 2)
	{
		for (int x = 0; x < amap->width; x += 2)
		{
			localGame.DrawTexture(mapTextures[4], x * GSCALE + GSCALE + xoffset, y * GSCALE + GSCALE + yoffset, 1);
		}
	}

	for (int y = 0; y < amap->height; y++)
	{
		for (int x = 0; x < amap->width; x++)
		{
			switch (amap->map[y][x])
			{
			case '#':
				currentTexture = &mapTextures[1 + (x % 2) * 10];
				break;
			case '.':
				currentTexture = &mapTextures[5];
				break;
			case 'W':
				currentTexture = &mapTextures[15];
				break;
			case 'T':
				currentTexture = &mapTextures[6];
				break;
			case 'D':
				currentTexture = &mapTextures[3];
				break;
			default:
				currentTexture = &mapTextures[0];
				break;
			}

			if (dummy) switch (amap->map[y][x])
			{
			case 'B':
				currentTexture = &mapTextures[2];
				break;
			case 'P':
				currentTexture = &mapTextures[7];
			};

			localGame.DrawTexture(*currentTexture, x * GSCALE + GSCALE / 2 + xoffset, y * GSCALE + GSCALE / 2 + yoffset, 1);
		}
	}

	if (amap->height % 2 == 1)
	{
		for (int x = 0; x <= amap->width; x++)
		{
			localGame.DrawTexture(mapTextures[5], x * GSCALE + GSCALE / 2 + xoffset, amap->height * GSCALE + GSCALE / 2 + yoffset, 1);
		}
	}
	if (amap->width % 2 == 1)
	{
		for (int y = 0; y <= amap->height; y++)
		{
			localGame.DrawTexture(mapTextures[5], amap->width * GSCALE + GSCALE / 2 + xoffset, y * GSCALE + GSCALE / 2 + yoffset, 1);
		}
	}
}

void Scenes::RenderGameDynamics(Game& localGame) //renderowanie dynamicznych elementw mapy
{
	Map* amap = &mapManager.maps[mapManager.selectedMap];

	int xoffset = (localGame.windowWidth / 2) - (amap->width * GSCALE / 2);
	int yoffset = (localGame.windowHeight / 2) - (amap->height * GSCALE / 2);
	
	int spriteX, spriteY;

	for (int i = 0; i < 2; i++)
	{
		for (int b = 0; b < amap->boxCount; b++)
		{
			if (!amap->isDrowned[b] == i || amap->boxSpriteMovement[b] != 0)
			{
				int diffoffset = 0;

				spriteX = amap->boxPosition[0][b] * GSCALE + GSCALE / 2 + xoffset;
				spriteY = amap->boxPosition[1][b] * GSCALE + GSCALE / 2 + yoffset;

				if (amap->boxSpriteMovement[b] != 0)
				{
					if (amap->difficultylevel == 1) //ludzik musi robi lekkie opnienie
					{
						diffoffset = 10.0f - ((amap->boxSpriteMovement[b] - 10) * 0.3125f);
						if (amap->boxSpriteMovement[b] < 10) diffoffset = amap->boxSpriteMovement[b];
					}

					switch (amap->boxSpriteMovementDirection[b])
					{
					case 0:
						spriteY = spriteY + GSCALE - amap->boxSpriteMovement[b] + diffoffset;
						break;

					case 1:
						spriteX = spriteX - GSCALE + amap->boxSpriteMovement[b] - diffoffset;
						break;

					case 2:
						spriteY = spriteY - GSCALE + amap->boxSpriteMovement[b] - diffoffset;
						break;

					case 3:
						spriteX = spriteX + GSCALE - amap->boxSpriteMovement[b] + diffoffset;
						break;
					}
				}

				localGame.DrawTexture(mapTextures[3 - i], spriteX, spriteY, 1);
			}
		}
	}

	spriteX = amap->playerPosition[0] * GSCALE + GSCALE / 2 + xoffset;
	spriteY = amap->playerPosition[1] * GSCALE + GSCALE / 2 + yoffset;

	if (amap->playerSpriteMovement != 0)
	{
		switch (amap->playerRotation)
		{
		case 0:
			spriteY = spriteY + GSCALE - amap->playerSpriteMovement;
			break;

		case 1:
			spriteX = spriteX - GSCALE + amap->playerSpriteMovement;
			break;

		case 2:
			spriteY = spriteY - GSCALE + amap->playerSpriteMovement;
			break;

		case 3:
			spriteX = spriteX + GSCALE - amap->playerSpriteMovement;
			break;
		}
	}

	playerTextures[amap->difficultylevel-1].RenderTile(
		localGame,
		(amap->playerSpriteMovement * playerTextures[amap->difficultylevel-1].tileXcount) / GSCALE,
		!pushed,
		spriteX,
		spriteY,
		1,
		amap->playerRotation * 90
	);
	localGame.DrawTexture(lightOverlay, spriteX, spriteY, 1);
	for (int x = -4; x <= 4; x++)
		for (int y = -4; y <= 4; y++)
			if (x != 0 || y != 0)
				localGame.DrawTexture(darknessOverlay, spriteX + x * 256, spriteY + y * 256, 256);
}

void Scenes::GameUpdate(Game& localGame) //wywietlanie gry
{
	if (ticksInCurrentScene == 0)
	{
		amap = &mapManager.maps[mapManager.selectedMap];
		amap->Reset();

		asave = &saveManager.saves[selectedSave];

		animationTimer = 0;
		ticksAtFirstMove = -1;
		timerTime = -1;
		gamePaused = false;

		if (selectedSave != -1)
		{
			if (!asave->restartLevel)
			{
				amap->boxCount = asave->boxCount;
				amap->movesCount = asave->movesCount;
				amap->playerPosition[0] = asave->playerPositionX;
				amap->playerPosition[1] = asave->playerPositionY;
				amap->playerRotation = asave->playerRotation;
				ticksAtFirstMove = asave->timeLeft - amap->timeLimit * MAX_FPS + 3 * MAX_FPS;
				asave->restartLevel = true;

				for (int i = 0; i < amap->boxCount; i++)
				{
					amap->boxPosition[0][i] = asave->boxPositionX[i];
					amap->boxPosition[1][i] = asave->boxPositionY[i];
					amap->isDrowned[i] = asave->isDrowned[i];
				}

				if (selectedDifficulty == 99)
				{
					ticksAtFirstMove = -asave->timeLeft;
				}

				amap->CheckIfFinished();
			}

			selectedSaveName = asave->name;
		}

		backButton.y = 96;

		pauseButton = restartButton = backButton;
		restartButton.y = 144;
		pauseButton.y = 48;

		if (selectedDifficulty == -1) timerColor = { 255,0,0,0 };
		else
		{
			timerColor = { 255,255,255,0 };
		}
	}

	const Uint8* state = SDL_GetKeyboardState(NULL);

	if (ticksInCurrentScene < MAX_FPS * 3 && selectedDifficulty != 99)
	{
		localGame.RenderRzufText(SmallerSans, ("Poziom " + to_string(mapManager.selectedMap + 1)).c_str(), round(localGame.windowWidth * 0.5f), round(localGame.windowHeight * 0.3f), 1, 3);
		localGame.RenderRzufText(SmallerSans, amap->name.c_str(), round(localGame.windowWidth * 0.5f), round(localGame.windowHeight * 0.4f), 1, 2);
	}
	else
	{
		RenderGameMap(localGame);
		RenderGameDynamics(localGame);

		if (!(amap->end || gamePaused))
		{
			if (restartButton.Update(localGame)) ticksInCurrentScene = -1;
			if (backButton.Update(localGame))
			{


				if (selectedDifficulty == -1)
				{
					saveManager.CreateSave(
						selectedSaveName,
						amap,
						ticksAtFirstMove == -1 || timerTime == 0 ? 1 : 0,
						timerTime,
						scores,
						mapManager.selectedMap
					);
				}

				if (selectedDifficulty == 99)
				{
					if (afteredit)
						currentScene = 5;
					else if (ticksAtFirstMove != -1)
					{
						gamePaused = true;
						promptsave = true;
						animationTimer = 40;
					}
					else
					{
						currentScene = 1;
					}
				}
				else
				{
					currentScene = 0;
				}
			}
			if (pauseButton.Update(localGame)) gamePaused = true;

			localGame.DrawTexture(pauseOverlay, 48, 48, 1);
			localGame.DrawTexture(backOverlay, 48, 96, 1);
			localGame.DrawTexture(restartOverlay, 48, 144, 1);

			int minutes, seconds, miliseconds;

			if (selectedDifficulty == -1) //jeli poza treningiem
			{
				if (ticksAtFirstMove == -1)	timerTime = amap->timeLimit * MAX_FPS;
				else timerTime = amap->timeLimit * MAX_FPS - ticksInCurrentScene + ticksAtFirstMove;

				if (timerTime <= 0)
				{
					timerTime = 0;
					amap->end = true;
				}
			}
			else //jeli w treningu
			{
				if (ticksAtFirstMove == -1) timerTime = 0;
				else timerTime = ticksInCurrentScene - ticksAtFirstMove;
			}

			minutes = (timerTime / (MAX_FPS * 60));
			seconds = (timerTime / MAX_FPS) - 60 * minutes;
			miliseconds = (((float)timerTime / MAX_FPS) - (seconds)-(60 * minutes)) * (1000);

			sprintf_s(buf, "%02i:%02i.%03i", minutes, seconds, miliseconds);

			if(selectedDifficulty == -1 && ticksAtFirstMove != -1 && minutes == 0 && seconds <= 20 && timerTime % MAX_FPS == 0)
				soundManager.PlayEffect("effect_tick");

			if (amap->playerSpriteMovement == 0)
			{
				moved = false;
				pushed = false;

				if (state[SDL_SCANCODE_W] || state[SDL_SCANCODE_UP]) //xy autofillowane w funkcji no bo gracz
				{
					switch (amap->MoveHere(0, 0, 0, -1, selectedDifficulty == -1))
					{
					case 2:
						pushed = true;
					case 1:
						amap->playerPosition[1]--;
						amap->playerRotation = 0;
						moved = true;
						break;
					}

				}
				else if (state[SDL_SCANCODE_S] || state[SDL_SCANCODE_DOWN])
				{
					switch (amap->MoveHere(0, 0, 2, -1, selectedDifficulty == -1))
					{
					case 2:
						pushed = true;
					case 1:
						amap->playerPosition[1]++;
						amap->playerRotation = 2;
						moved = true;
						break;
					}
				}
				else if (state[SDL_SCANCODE_A] || state[SDL_SCANCODE_LEFT])
				{
					switch (amap->MoveHere(0, 0, 3, -1, selectedDifficulty == -1))
					{
					case 2:
						pushed = true;
					case 1:
						amap->playerPosition[0]--;
						amap->playerRotation = 3;
						moved = true;
						break;
					}

				}
				else if (state[SDL_SCANCODE_D] || state[SDL_SCANCODE_RIGHT])
				{
					switch (amap->MoveHere(0, 0, 1, -1, selectedDifficulty == -1))
					{
					case 2:
						pushed = true;
					case 1:
						amap->playerPosition[0]++;
						amap->playerRotation = 1;
						moved = true;
						break;
					}

				}
				/* !DEBUG!
				else if (state[SDL_SCANCODE_E] && state[SDL_SCANCODE_LCTRL])
				{
					amap->end = true;
					amap->finishedBoxes = amap->targetCount;
				}
				else if (state[SDL_SCANCODE_R] && state[SDL_SCANCODE_LCTRL])
				{
					LoadResources(localGame);
				}
				*/

				if (moved)
				{
					amap->playerSpriteMovement = 1;
					amap->movesCount++;
					if (ticksAtFirstMove == -1) ticksAtFirstMove = ticksInCurrentScene;
					if (amap->splashed)
					{
						amap->splashed = false;
						soundManager.PlayEffect("effect_splash");
					}

					if (pushed)
					{
						soundManager.PlayEffect("effect_slide");
					}
				}

			}

			if (amap->playerSpriteMovement > 0)
			{
				amap->playerSpriteMovement += difficultySpeeds[amap->difficultylevel - 1];
				if (amap->playerSpriteMovement > GSCALE) amap->playerSpriteMovement = 0;
			}

			for (int b = 0; b < amap->boxCount; b++)
			{
				if (amap->boxSpriteMovement[b] > 0)
				{
					amap->boxSpriteMovement[b] += difficultySpeeds[amap->difficultylevel - 1];

					if (amap->boxSpriteMovement[b] > GSCALE)
					{
						amap->boxSpriteMovement[b] = 0;
						amap->CheckIfFinished();
					}
				}
			}

		}
		else
		{
		ticksInCurrentScene--;

			if (animationTimer < 40)
			{
				localGame.DrawTexture(blackDot, round(localGame.windowWidth * 0.5f) + animationTimer * 3, round(localGame.windowHeight * 0.5f), animationTimer);
				localGame.DrawTexture(blackDot, round(localGame.windowWidth * 0.5f) - animationTimer * 3, round(localGame.windowHeight * 0.5f), animationTimer);

				animationTimer += 2;
			}
			else
			{
				if (promptsave)
				{
					localGame.DrawTexture(igmBackgrounds[8], round(localGame.windowWidth * 0.5f), round(localGame.windowHeight * 0.5f), 2);
					igmButtons[0].y = round(localGame.windowHeight / 2) + 64;
					igmButtons[2].y = round(localGame.windowHeight / 2) + 64;

					if (igmButtons[0].Update(localGame)) // tak
					{
						saveManager.CreateSave(
							"ZZ-EDITOR-",
							amap,
							0,
							timerTime,
							scores,
							mapManager.selectedMap
						);
						promptsave = false;
					}

					if (igmButtons[2].Update(localGame)) // nie
					{
						promptsave = false;
					}

					if (!promptsave)
					{
						currentScene = 0;
						igmButtons[0].y = round(localGame.windowHeight / 2) + 196;
						igmButtons[2].y = round(localGame.windowHeight / 2) + 196;

					}
				}
				else
				{
					if (gamePaused) //jeli pauza
					{
						if (selectedDifficulty == -1) localGame.DrawTexture(igmBackgrounds[2], round(localGame.windowWidth * 0.5f), round(localGame.windowHeight * 0.5f), 2);
						else if (selectedDifficulty == 99) localGame.DrawTexture(igmBackgrounds[7], round(localGame.windowWidth * 0.5f), round(localGame.windowHeight * 0.5f), 2);
						else localGame.DrawTexture(igmBackgrounds[4], round(localGame.windowWidth * 0.5f), round(localGame.windowHeight * 0.5f), 2);
						if (unpauseButton.Update(localGame))
						{
							gamePaused = false;
							animationTimer = 0;
						}
					}
					else if (amap->finishedBoxes == amap->targetCount) //jeli faktycznie przeszede
					{
						if (selectedDifficulty == -1) localGame.DrawTexture(igmBackgrounds[0], round(localGame.windowWidth * 0.5f), round(localGame.windowHeight * 0.5f), 2);
						else if (selectedDifficulty == 99) localGame.DrawTexture(igmBackgrounds[6], round(localGame.windowWidth * 0.5f), round(localGame.windowHeight * 0.5f), 2);
						else localGame.DrawTexture(igmBackgrounds[3], round(localGame.windowWidth * 0.5f), round(localGame.windowHeight * 0.5f), 2);
					}
					else //jeli przegrae
					{
						if (amap->drowned) localGame.DrawTexture(igmBackgrounds[5], round(localGame.windowWidth * 0.5f), round(localGame.windowHeight * 0.5f), 2);
						else localGame.DrawTexture(igmBackgrounds[1], round(localGame.windowWidth * 0.5f), round(localGame.windowHeight * 0.5f), 2);
					}

					if (igmButtons[0].Update(localGame)) // przycisk 0 to zawsze restart
					{
						ticksInCurrentScene = -1;
					}

					if (igmButtons[1].Update(localGame)) // przycisk 1 to zawsze wyjcie
					{
						if (selectedDifficulty == 99 && amap->finishedBoxes != amap->targetCount && ticksAtFirstMove != -1)
						{
							promptsave = true;

						}
						else
						{
							currentScene = 0;


							if (selectedDifficulty == -1)
							{
								if (amap->finishedBoxes == amap->targetCount) //jeli przeszede, zapis bdzie dotyczy ju nastpnej mapy
								{
									saveManager.CreateSave(
										selectedSaveName,
										amap,
										1,
										timerTime,
										scores,
										mapManager.selectedMap < mapManager.mapsCount - 1 ? mapManager.selectedMap + 1 : 20
									);
								}
								else
								{
									saveManager.CreateSave(
										selectedSaveName,
										amap,
										ticksAtFirstMove == -1 || timerTime == 0 ? 1 : 0 || amap->drowned,
										timerTime,
										scores,
										mapManager.selectedMap
									);
								}

							}
						}

					}

					localGame.RenderRzufText(SmallerSans, (to_string(amap->finishedBoxes) + " / " + to_string(amap->targetCount)).c_str(), round(localGame.windowWidth * 0.5f), round(localGame.windowHeight * 0.5f) - 122 + 39, 0, 2);
					localGame.RenderRzufText(SmallerSans, to_string(amap->movesCount).c_str(), round(localGame.windowWidth * 0.5f), round(localGame.windowHeight * 0.5f) - 122 + 39 * 2, 0, 2);
					localGame.RenderRzufText(SmallerSans, buf, round(localGame.windowWidth * 0.5f), round(localGame.windowHeight * 0.5f) - 122 + 39 * 3, 0, 2);

					if (selectedDifficulty != -1)
					{
						if (igmButtons[2].Update(localGame))
						{
							ticksInCurrentScene = -1;

							if (selectedDifficulty == 99) currentScene = 5; //jeli w trybie customowej mapy, wr do edytora, jeli w treningu, wylosuj now map
							else mapManager.selectedMap = mapManager.GetRandomMapID(selectedDifficulty);
						}

						localGame.RenderRzufText(SmallerSans, difficultyNames[amap->difficultylevel - 1], round(localGame.windowWidth * 0.5f), round(localGame.windowHeight * 0.5f) - 122, 0, 2);
					}
					else
					{
						int sum = 0;
						for (int m = 0; m < mapManager.selectedMap; m++) sum += scores[m];
						
						if (amap->finishedBoxes == amap->targetCount)
						{
							if (mapManager.selectedMap < mapManager.mapsCount - 1 && igmButtons[2].Update(localGame))
							{
								if (amap->difficultylevel < mapManager.maps[mapManager.selectedMap + 1].difficultylevel)
								{
									currentScene = 6;
								}
								else
								{
									ticksInCurrentScene = -1;
								}

								mapManager.selectedMap++;
							}


							scores[mapManager.selectedMap] = amap->CalculateScore();
							sum += amap->CalculateScore();
							
							sprintf_s(pktbuf, "x%.2f", 1.0f / (1.0 + amap->movesCount * 0.001f));

							localGame.RenderRzufText(SmallerSans, (to_string(scores[mapManager.selectedMap]) + "pkt.").c_str(), round(localGame.windowWidth * 0.5f), round(localGame.windowHeight * 0.5f) - 122 + 39 * 5, 0, 2);

							localGame.RenderRzufText(SmallerSans, ("+" + to_string(amap->finishedBoxes * 10) + "pkt.").c_str(), round(localGame.windowWidth * 0.5f) + 150, round(localGame.windowHeight * 0.5f) - 122 + 39, 0, 2);
							localGame.RenderRzufText(SmallerSans, ("x" + to_string(amap->difficultylevel)).c_str(), round(localGame.windowWidth * 0.5f) + 150, round(localGame.windowHeight * 0.5f) - 122, 0, 2);
							localGame.RenderRzufText(SmallerSans, pktbuf, round(localGame.windowWidth * 0.5f) + 150, round(localGame.windowHeight * 0.5f) - 122 + 39 * 2, 0, 2);


						}

						localGame.RenderRzufText(SmallerSans, (to_string(mapManager.selectedMap + 1)).c_str(), round(localGame.windowWidth * 0.5f), round(localGame.windowHeight * 0.5f) - 122, 0, 2);
						localGame.RenderRzufText(SmallerSans, (to_string(sum) + "pkt.").c_str(), round(localGame.windowWidth * 0.5f), round(localGame.windowHeight * 0.5f) - 122 + 39 * 6, 0, 2);

					}
				}
			}
		}

		localGame.RenderText(
			Sans,
			timerColor,
			buf,
			localGame.windowWidth - 128,
			16,
			0
		);
	}

}

void Scenes::SavesMenuUpdate(Game& localGame) //wywietlanie tabeli wynikw
{
	if (ticksInCurrentScene == 0)
	{
		backButton.y = 48;

		saveManager.ListSaves();

		floppyButtons = new Button[saveManager.savesCount];

		for (int i = 0; i < saveManager.savesCount; i++)
		{
			floppyButtons[i] = floppyButton;
			floppyButtons[i].x = round(localGame.windowWidth * 0.5f) - 331 + saveManager.saves[i].currentLevel * 40;
			floppyButtons[i].y = round(localGame.windowHeight * 0.2f) + 62 + 40 * i;
		}

		saveManager.Podium();
	}

	localGame.DrawTexture(tableHeaderImage, round(localGame.windowWidth * 0.5f), round(localGame.windowHeight * 0.2f), 2);
	if (backButton.Update(localGame)) currentScene = 0;
	localGame.DrawTexture(backOverlay, 48, 48, 1);


	for (int i = 0; i < saveManager.savesCount; i++)
	{
		if (saveManager.saves[i].name != "ZZ-EDITOR-")
		{
			int xlevel = round(localGame.windowWidth * 0.5f);
			int ylevel = round(localGame.windowHeight * 0.2f) + 64 + 40 * i;

			localGame.DrawTexture(tableEntryImage, xlevel, ylevel, 2);
			localGame.RenderText(Sans, { 255,255,255,0 }, saveManager.saves[i].name.c_str(), xlevel - 454, ylevel - 12, 1);

			for (int j = 0; j < 3; j++) if (saveManager.podium[j] == i) localGame.DrawTexture(medalImage[j], xlevel - 530, ylevel - 4, 2); //rysowanie medali

			int sum = 0;

			for (int m = 0; m < saveManager.saves[i].currentLevel; m++)
			{
				localGame.RenderText(SmallerSans, { 255,255,255,0 }, to_string(saveManager.saves[i].levelScores[m]).c_str(), xlevel - 332 + m * 40, ylevel - 8, 1);
				sum += saveManager.saves[i].levelScores[m];
			}

			if (saveManager.saves[i].currentLevel != 20)
			{
				if (floppyButtons[i].Update(localGame))
				{
					mapManager.ListMaps();
					selectedSave = i;
					selectedDifficulty = -1;
					mapManager.selectedMap = saveManager.saves[selectedSave].currentLevel;
					currentScene = 2;
					for (int i = 0; i < 20; i++) scores[i] = saveManager.saves[selectedSave].levelScores[i];
				}
			}

			localGame.RenderText(SmallerSans, { 255,255,255,0 }, to_string(sum).c_str(), xlevel + 460, ylevel - 8, 0);
		}
	}
}

void Scenes::RenderEditorTools(Game& localGame) //wywietlanie narzdzi edytora map
{
	for (int i = 0; i < 8; i++)
	{
		localGame.DrawTexture(mapTextures[i], localGame.windowWidth - 32, 192 + 64 * i, i == 4 ? 1 : 2);
		if (editorToolsButtons[i].Update(localGame)) selectedTool = i;
	}

	localGame.DrawTexture(mapTextures[selectedTool], localGame.windowWidth - 32, 64, selectedTool == 4 ? 1 : 2);
	localGame.DrawTexture(editorOverlay, 160, 120, 1);

	int highlighted = 0;

	if (backButton.a == 1) highlighted = 1;
	else
	{
		for (int i = 0; i < 9; i++)
		{
			if (editorLeftSideButtons[i].a == 1) highlighted = 2 + i;
			if (editorToolsButtons[i].a == 1) highlighted = 11 + i;
		}
	}

	int prevheight = amap->height;
	int prevwidth = amap->width;

	int saveerror = 0;

	if (editorLeftSideButtons[0].Update(localGame)) saveerror = mapManager.SaveMapToFile();
	if (editorLeftSideButtons[1].Update(localGame))
	{


		string filename = amap->filename;
		string tempfilename = filename.substr(0, filename.size() - 4) + "temp.map";
		string newfilename = filename.substr(0, filename.size() - 4) + "copy" + to_string(rand()) + ".map";

		std::filesystem::copy(filename, tempfilename);
		std::filesystem::rename(filename, newfilename);
		amap->filename = newfilename;

		std::filesystem::rename(tempfilename, filename);
		saveerror = mapManager.SaveMapToFile();
	}

	if (editorLeftSideButtons[2].Update(localGame))
	{
		saveerror = mapManager.SaveMapToFile();
		if (saveerror == 1)
		{
			currentScene = 2;
		}
	}

	if (saveerror)
	{

		editorerrortime = 5 * MAX_FPS;

		switch (saveerror)
		{
		case 1:
			editorerror = "Zapisano";
			editorLeftSideButtons[0].a = 0;
			editorLeftSideButtons[2].a = 0;
			break;
		case 10:
			editorerror = "Nie znaleziono miejsca startu!";
			break;
		case 11:
			editorerror = "Znaleziono wiecej niz jedno miejsce startu!";
			break;
		case 12:
			editorerror = "Liczba pozycji docelowych przewyzsza liczbe skrzyn!";
			break;
		case 13:
			editorerror = "Nie znaleziono zadnych skrzyn!";
			break;
		}
	}

	if (editorLeftSideButtons[3].Update(localGame)) amap->width--;
	if (editorLeftSideButtons[4].Update(localGame)) amap->width++;
	if (editorLeftSideButtons[5].Update(localGame)) amap->height--;
	if (editorLeftSideButtons[6].Update(localGame)) amap->height++;
	if (editorLeftSideButtons[7].Update(localGame)) amap->difficultylevel--;
	if (editorLeftSideButtons[8].Update(localGame)) amap->difficultylevel++;
	if (backButton.Update(localGame)) currentScene = 1;

	if (amap->height > 20)
	{
		amap->height = 20;
		editorerror = "Maksymalny rozmiar mapy w osi Y to 20!";
		editorerrortime = 5 * MAX_FPS;
	}
	if (amap->height < 3)
	{
		amap->height = 3;
		editorerror = "Minimalny rozmiar mapy w osi Y to 3!";
		editorerrortime = 5 * MAX_FPS;
	}
	if (amap->width > 30)
	{
		amap->width = 30;
		editorerror = "Maksymalny rozmiar mapy w osi X to 30!";
		editorerrortime = 5 * MAX_FPS;
	}
	if (amap->width < 3)
	{
		amap->width = 3;
		editorerror = "Minimalny rozmiar mapy w osi X to 3!";
		editorerrortime = 5 * MAX_FPS;
	}
	if (amap->difficultylevel < 1) amap->difficultylevel = 3;
	if (amap->difficultylevel > 3) amap->difficultylevel = 1;

	if (prevheight != amap->height || prevwidth != amap->width) amap->RewriteMapSize(prevwidth, prevheight);

	if (editorerrortime > 0) editorerrortime--;
	if (editorerror != " " && editorerrortime == 0) editorerror = " ";

	localGame.RenderText(Sans, { 255,255,255,0 }, highlightStrings[highlighted], 32, localGame.windowHeight - 32, 0);
	localGame.RenderText(Sans, { 255,0,0,0 }, editorerror, 32, localGame.windowHeight - 64, 0);
	localGame.RenderText(Sans, { 255,255,255,0 }, to_string(amap->height).c_str(), 96, 88, 1);
	localGame.RenderText(Sans, { 255,255,255,0 }, to_string(amap->width).c_str(), 96, 136, 1);
	localGame.RenderText(Sans, { 255,255,255,0 }, to_string(amap->difficultylevel).c_str(), 96, 184, 1);
}

void Scenes::MapEditorUpdate(Game& localGame) //wywietlanie edytora map (oglnie)
{
	if (ticksInCurrentScene == 0)
	{
		selectedTool = 0;
		amap = &mapManager.maps[mapManager.selectedMap];
		amap->Reset();
		backButton.y = 48;
		afteredit = true;

		if (amap->difficulty == 0)
		{
			editorLeftSideButtons[0].a = 3;
			editorLeftSideButtons[2].a = 3;
		}
		else
		{
			editorLeftSideButtons[0].a = 0;
			editorLeftSideButtons[2].a = 0;
		}

		editorerror = " ";
		editorerrortime = 0;
	}

	RenderGameMap(localGame, true);
	RenderEditorTools(localGame);

	int xcursor = ((amap->width * GSCALE / 2) - (localGame.windowWidth / 2) + localGame.mouseX) / GSCALE;
	int ycursor = ((amap->height * GSCALE / 2) - (localGame.windowHeight / 2) + localGame.mouseY) / GSCALE;
	int xoffset = (localGame.windowWidth / 2) - (amap->width * GSCALE / 2) + GSCALE / 2;
	int yoffset = (localGame.windowHeight / 2) - (amap->height * GSCALE / 2) + GSCALE / 2;
	if (xcursor >= 0 && xcursor < amap->width && ycursor >= 0 && ycursor < amap->height)
	{
		localGame.DrawTexture(tileOverlay, xoffset + xcursor * GSCALE, yoffset + ycursor * GSCALE, 1);

		if (localGame.mouseL)
		{
			amap->map[ycursor][xcursor] = mapChars[selectedTool];
		}
	}
}

void Scenes::CongratulationsUpdate(Game& localGame)
{
	igmButtons[1].y = round(localGame.windowHeight * 0.85f);

	localGame.DrawTexture(congratulationsHeader, round(localGame.windowWidth / 2), round(localGame.windowHeight * 0.15f), 2);
	localGame.DrawTexture(congratulationsArrow, round(localGame.windowWidth / 2), round(localGame.windowHeight * 0.5f), 1);
	localGame.DrawTexture(congratulationsButton, round(localGame.windowWidth / 2), round(localGame.windowHeight * 0.85f), 1);

	localGame.DrawTexture(difficultyImages[mapManager.maps[mapManager.selectedMap - 1].difficultylevel - 1], round(localGame.windowWidth / 2) - 192, round(localGame.windowHeight * 0.5f), 1);
	localGame.DrawTexture(difficultyImages[mapManager.maps[mapManager.selectedMap].difficultylevel - 1], round(localGame.windowWidth / 2) + 192, round(localGame.windowHeight * 0.5f), 1);

	if (igmButtons[1].Update(localGame))
	{
		currentScene = 2;
		igmButtons[1].y = igmButtons[0].y;
	}
}

void Scenes::Update(Game& localGame) //update scen
{

	if (ticksInCurrentScene == 1)
	{
		prevScene = currentScene;
	}

	if (prevScene != currentScene)
	{
		ticksInCurrentScene = 0;

		if (prevScene == 2 || prevScene == -1)
		{
			soundManager.PlayMusic("music_menu");
		}
		else if (currentScene == 2)
		{
			soundManager.PlayMusic("music_game");
		}
	}

	switch (currentScene)
	{
	case 0:
		MainMenuUpdate(localGame);
		break;

	case 1:
		MapMenuUpdate(localGame);
		break;

	case 2:
		GameUpdate(localGame);
		break;

	case 3:
		DifficultyMenuUpdate(localGame);
		break;

	case 4:
		SavesMenuUpdate(localGame);
		break;

	case 5:
		MapEditorUpdate(localGame);
		break;

	case 6:
		CongratulationsUpdate(localGame);
		break;
	}

	ticksInCurrentScene++;
}