#include "Spritesheet.h"

Spritesheet::Spritesheet()
{

}

Spritesheet::~Spritesheet()
{

}

void Spritesheet::Init(SDL_Texture* baseTexture, int tileW, int tileH)
{
	int textureXsize, textureYsize;

	SDL_QueryTexture(baseTexture, NULL, NULL, &textureXsize, &textureYsize);

	this->tileXcount = textureXsize / tileW;
	this->tileYcount = textureYsize / tileH;
	this->tileH = tileH;
	this->tileW = tileW;
	this->baseTexture = baseTexture;

}

void Spritesheet::RenderTile(Game& localGame, int tileX, int tileY, int x, int y, int scale, double rotation)
{

	if (tileX >= this->tileXcount) tileX = tileXcount-1;
	if (tileY >= this->tileYcount) tileY = tileYcount-1;

	SDL_Rect tmpRect;
	tmpRect.h = this->tileH * scale;
	tmpRect.w = this->tileW * scale;
	tmpRect.x = x - tmpRect.w / 2;
	tmpRect.y = y - tmpRect.h / 2;

	SDL_Rect cropRect;
	cropRect.h = this->tileH;
	cropRect.w = this->tileW;
	cropRect.x = tileX * tileW;
	cropRect.y = tileY * tileH;

	SDL_RenderCopyEx(localGame.renderer, this->baseTexture, &cropRect, &tmpRect, rotation, NULL, SDL_FLIP_NONE);
}